diff -Naur openssl-1.0.0q.orig/e_os.h openssl-1.0.0q/e_os.h
--- openssl-1.0.0q.orig/e_os.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/e_os.h	2017-04-25 16:23:40.893798231 +0200
@@ -109,12 +109,16 @@
 # endif
 #endif
 
+#ifdef EPOC
+#define GROUP_USER_ID_IS_MEANINGLESS
+#endif
+
 /********************************************************************
  The Microsoft section
  ********************************************************************/
 /* The following is used because of the small stack in some
  * Microsoft operating systems */
-#if defined(OPENSSL_SYS_MSDOS) && !defined(OPENSSL_SYSNAME_WIN32)
+#if defined(OPENSSL_SYS_MSDOS) && !defined(OPENSSL_SYSNAME_WIN32) && !defined(OPERA_SMALL_VERSION)
 #  define MS_STATIC	static
 #else
 #  define MS_STATIC
@@ -134,6 +138,15 @@
 #  define GETPID_IS_MEANINGLESS
 #endif
 
+#if defined(BREW) && !defined(GETPID_IS_MEANINGLESS)
+#  define GETPID_IS_MEANINGLESS
+#endif
+
+
+#if defined(EPOC) && !defined(GETPID_IS_MEANINGLESS)
+#  define GETPID_IS_MEANINGLESS
+#endif
+
 #ifdef WIN32
 #define get_last_sys_error()	GetLastError()
 #define clear_sys_error()	SetLastError(0)
@@ -227,6 +240,8 @@
 
 #if (defined(WINDOWS) || defined(MSDOS))
 
+#ifndef OPERA_SMALL_VERSION
+
 #  ifdef __DJGPP__
 #    include <unistd.h>
 #    include <sys/stat.h>
@@ -350,6 +365,8 @@
 #    define _kbhit kbhit
 #  endif
 
+#endif /* !OPERA_SMALL_VERSION */
+
 #  define EXIT(n) exit(n)
 #  define LIST_SEPARATOR_CHAR ';'
 #  ifndef X_OK
@@ -365,11 +382,7 @@
 #  define SSLEAY_CONF	OPENSSL_CONF
 #  define NUL_DEV	"nul"
 #  define RFILE		".rnd"
-#  ifdef OPENSSL_SYS_WINCE
-#    define DEFAULT_HOME  ""
-#  else
-#    define DEFAULT_HOME  "C:"
-#  endif
+#  define DEFAULT_HOME  "C:"
 
 /* Avoid Visual Studio 13 GetVersion deprecated problems */
 #if defined(_MSC_VER) && _MSC_VER>=1800
@@ -386,12 +399,14 @@
 #    define VMS 1
   /* some programs don't include stdlib, so exit() and others give implicit 
      function warnings */
+#ifndef OPERA_SMALL_VERSION
 #    include <stdlib.h>
 #    if defined(__DECC)
 #      include <unistd.h>
 #    else
 #      include <unixlib.h>
 #    endif
+#endif /* !OPERA_SMALL_VERSION */
 #    define OPENSSL_CONF	"openssl.cnf"
 #    define SSLEAY_CONF		OPENSSL_CONF
 #    define RFILE		".rnd"
@@ -452,6 +467,7 @@
 #    ifdef OPENSSL_SYS_MPE
 #      define NO_SYS_PARAM_H
 #    endif
+#ifndef OPERA_SMALL_VERSION
 #    ifdef OPENSSL_UNISTD
 #      include OPENSSL_UNISTD
 #    else
@@ -460,6 +476,7 @@
 #    ifndef NO_SYS_TYPES_H
 #      include <sys/types.h>
 #    endif
+#endif /* !OPERA_SMALL_VERSION */
 #    if defined(NeXT) || defined(OPENSSL_SYS_NEWS4)
 #      define pid_t int /* pid_t is missing on NEXTSTEP/OPENSTEP
                          * (unless when compiling with -D_POSIX_SOURCE,
@@ -492,6 +509,10 @@
 
 /*************/
 
+#ifdef EXTERNAL_SSL_OPENSSL_IMPLEMENTATION
+#define USE_SOCKETS
+#endif
+
 #ifdef USE_SOCKETS
 #  if defined(WINDOWS) || defined(MSDOS)
       /* windows world */
@@ -533,6 +554,7 @@
 #      define SSLeay_Read(a,b,c)	read_s(a,b,c)
 #      define SHUTDOWN(fd)		close_s(fd)
 #      define SHUTDOWN2(fd)		close_s(fd)
+       extern HINSTANCE _hInstance;
 #    endif
 
 #  elif defined(MAC_OS_pre_X)
@@ -566,6 +588,7 @@
 
 #  else
 
+#if !defined(OPERA_SMALL_VERSION) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
 #    ifndef NO_SYS_PARAM_H
 #      include <sys/param.h>
 #    endif
@@ -623,6 +646,7 @@
 #        include <socketshr.h>
 #      endif
 #    endif
+#endif /* !OPERA_SMALL_VERSION */
 
 #    define SSLeay_Read(a,b,c)     read((a),(b),(c))
 #    define SSLeay_Write(a,b,c)    write((a),(b),(c))
@@ -686,6 +710,7 @@
 #define IRIX_CC_BUG	/* CDS++ up to V2.0Bsomething suffered from the same bug.*/
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 #if defined(OPENSSL_SYS_WINDOWS)
 #  define strcasecmp _stricmp
 #  define strncasecmp _strnicmp
@@ -705,10 +730,13 @@
 #    define strncasecmp strnicmp
 #  endif /* NETWARE_CLIB */
 #endif
+#endif /* !OPERA_SMALL_VERSION */
 
 #if defined(OPENSSL_SYS_OS2) && defined(__EMX__)
+#ifndef OPERA_SMALL_VERSION
 # include <io.h>
 # include <fcntl.h>
+#endif /* !OPERA_SMALL_VERSION */
 # define NO_SYSLOG
 #endif
 
diff -Naur openssl-1.0.0q.orig/e_os2.h openssl-1.0.0q/e_os2.h
--- openssl-1.0.0q.orig/e_os2.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/e_os2.h	2017-04-25 16:23:40.894798917 +0200
@@ -53,8 +53,6 @@
  *
  */
 
-#include <openssl/opensslconf.h>
-
 #ifndef HEADER_E_OS2_H
 #define HEADER_E_OS2_H
 
@@ -62,6 +60,8 @@
 extern "C" {
 #endif
 
+#include <openssl/opensslconf.h> /* OPENSSL_UNISTD */
+
 /******************************************************************************
  * Detect operating systems.  This probably needs completing.
  * The result is that at least one OPENSSL_SYS_os macro should be defined.
@@ -70,6 +70,12 @@
 
 #define OPENSSL_SYS_UNIX
 
+
+/* --------------------------------- Brew ---------------------------------- */
+#if defined(BREW)
+# undef OPENSSL_SYS_UNIX
+#endif
+
 /* ----------------------- Macintosh, before MacOS X ----------------------- */
 #if defined(__MWERKS__) && defined(macintosh) || defined(OPENSSL_SYSNAME_MAC)
 # undef OPENSSL_SYS_UNIX
@@ -101,7 +107,7 @@
 #  undef OPENSSL_SYS_UNIX
 #  define OPENSSL_SYS_WIN32_CYGWIN
 # else
-#  if defined(_WIN32) || defined(OPENSSL_SYSNAME_WIN32)
+#  if (defined(_WIN32) && !defined(EPOC) && !defined(BREW)) || defined(OPENSSL_SYSNAME_WIN32)
 #   undef OPENSSL_SYS_UNIX
 #   define OPENSSL_SYS_WIN32
 #  endif
@@ -132,7 +138,14 @@
 # ifndef OPENSSL_OPT_WINDLL
 #  if defined(_WINDLL) /* This is used when building OpenSSL to indicate that
                           DLL linkage should be used */
+#   if !defined(_WINDLL_HIDE_OPENSSL) /* _WINDLL is defiend by VS for SDK dlls
+						                 as well. OpenSSL leaks to export table
+										 and is not needed there. If you have
+										 DLL release and don't want OPENSSL_OPT_WINDLL,
+										 your probably want _WINDLL_HIDE_OPENSSL
+										 define in the VCProject */
 #   define OPENSSL_OPT_WINDLL
+#   endif //!_WINDLL_HIDE_OPENSSL
 #  endif
 # endif
 #endif
@@ -157,6 +170,11 @@
 # define OPENSSL_SYS_OS2
 #endif
 
+/* --------------------------------- Symbian ---------------------------------- */
+#if defined(EPOC)
+# undef OPENSSL_SYS_UNIX
+#endif
+
 /* --------------------------------- Unix ---------------------------------- */
 #ifdef OPENSSL_SYS_UNIX
 # if defined(linux) || defined(__linux__) || defined(OPENSSL_SYSNAME_LINUX)
@@ -256,14 +274,14 @@
 # define OPENSSL_EXPORT globalref
 # define OPENSSL_IMPORT globalref
 # define OPENSSL_GLOBAL globaldef
-#elif defined(OPENSSL_SYS_WINDOWS) && defined(OPENSSL_OPT_WINDLL)
+#elif defined(OPENSSL_SYS_WINDOWS) && defined(OPENSSL_OPT_WINDLL) && !defined OPERA_SMALL_VERSION
 # define OPENSSL_EXPORT extern __declspec(dllexport)
 # define OPENSSL_IMPORT extern __declspec(dllimport)
 # define OPENSSL_GLOBAL
 #else
 # define OPENSSL_EXPORT extern
 # define OPENSSL_IMPORT extern
-# define OPENSSL_GLOBAL
+# define OPENSSL_GLOBAL extern
 #endif
 #define OPENSSL_EXTERN OPENSSL_IMPORT
 
@@ -277,7 +295,17 @@
 	OPENSSL_DECLARE_GLOBAL(int,foobar);
 	#define foobar OPENSSL_GLOBAL_REF(foobar)
 */
-#ifdef OPENSSL_EXPORT_VAR_AS_FUNCTION
+#ifdef OPERA_SMALL_VERSION
+# define OPENSSL_IMPLEMENT_GLOBAL_OPERA_FUN(type,name)			     \
+	type *_shadow_##name(void) { return & g_opera->libopeay_module.m_data->_hide_##name; }
+# define OPENSSL_IMPLEMENT_GLOBAL_OPERA(type,name)			     \
+	type _hide_##name
+# define OPENSSL_IMPLEMENT_GLOBAL_OPERA_NAME(name) _hide_##name
+# define OPENSSL_IMPLEMENT_GLOBAL(type,name)			     \
+	extern type *_shadow_##name(void);
+# define OPENSSL_DECLARE_GLOBAL(type,name) type *_shadow_##name(void)
+# define OPENSSL_GLOBAL_REF(name) (*(_shadow_##name()))
+#elif defined OPENSSL_EXPORT_VAR_AS_FUNCTION
 # define OPENSSL_IMPLEMENT_GLOBAL(type,name,value)			\
 	type *_shadow_##name(void)					\
 	{ static type _hide_##name=value; return &_hide_##name; }
diff -Naur openssl-1.0.0q.orig/engines/.gitignore openssl-1.0.0q/engines/.gitignore
--- openssl-1.0.0q.orig/engines/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/engines/.gitignore	2017-04-25 16:23:40.894798917 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/engines/e_chil_err.c openssl-1.0.0q/engines/e_chil_err.c
--- openssl-1.0.0q.orig/engines/e_chil_err.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/engines/e_chil_err.c	2017-04-25 16:23:40.895798206 +0200
@@ -58,6 +58,9 @@
  * only reason strings will be preserved.
  */
 
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+
 #include <stdio.h>
 #include <openssl/err.h>
 #include "e_chil_err.h"
diff -Naur openssl-1.0.0q.orig/engines/e_cswift.c openssl-1.0.0q/engines/e_cswift.c
--- openssl-1.0.0q.orig/engines/e_cswift.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/engines/e_cswift.c	2017-04-25 16:23:40.896798892 +0200
@@ -56,6 +56,9 @@
  *
  */
 
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+
 #include <stdio.h>
 #include <string.h>
 #include <openssl/crypto.h>
diff -Naur openssl-1.0.0q.orig/engines/vendor_defns/hw_ubsec.h openssl-1.0.0q/engines/vendor_defns/hw_ubsec.h
--- openssl-1.0.0q.orig/engines/vendor_defns/hw_ubsec.h	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/engines/vendor_defns/hw_ubsec.h	2017-04-25 16:23:40.896798892 +0200
@@ -40,8 +40,8 @@
 
 typedef struct ubsec_crypto_context_s {
 	unsigned int	flags;
-	unsigned char	crypto[MAX_CRYPTO_KEY_LENGTH];
-	unsigned char 	auth[MAX_MAC_KEY_LENGTH];
+	unsigned char	crypto[MAX_CRYPTO_KEY_LENGTH]; /* ARRAY OK 20092005 yngve Unused file */
+	unsigned char 	auth[MAX_MAC_KEY_LENGTH];	 /* ARRAY OK 20092005 yngve Unused file */
 } ubsec_crypto_context_t, *ubsec_crypto_context_p;
 
 /* 
diff -Naur openssl-1.0.0q.orig/engines/vendor_defns/hwcryptohook.h openssl-1.0.0q/engines/vendor_defns/hwcryptohook.h
--- openssl-1.0.0q.orig/engines/vendor_defns/hwcryptohook.h	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/engines/vendor_defns/hwcryptohook.h	2017-04-25 16:23:40.897798739 +0200
@@ -65,7 +65,7 @@
  * please contact nCipher.
  *
  *
- * $Id: hwcryptohook.h,v 1.1 2002/10/11 17:10:59 levitte Exp $
+ * $Id$
  */
 
 #ifndef HWCRYPTOHOOK_H
diff -Naur openssl-1.0.0q.orig/libopeay_arrays.h openssl-1.0.0q/libopeay_arrays.h
--- openssl-1.0.0q.orig/libopeay_arrays.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/libopeay_arrays.h	2017-04-25 16:23:40.898798308 +0200
@@ -0,0 +1,44 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 1995-2008 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+#ifndef MODULES_LIBOPEAY_ARRAYS_H
+#define MODULES_LIBOPEAY_ARRAYS_H
+
+#ifdef GLOBAL_CONST_WRAPPER_BASE
+#undef GLOBAL_CONST_WRAPPER_BASE
+#endif
+#define GLOBAL_CONST_WRAPPER_BASE : public LibopeayModule::Libopeay_ConstBase
+
+#include "modules/url/tools/arrays.h"
+#include "modules/libopeay/libopeay_constants.h"
+
+#ifdef HAS_COMPLEX_GLOBALS
+#define OPENSSL_GLOBAL_ARRAY_NAME(name) g_##name
+#define OPENSSL_GLOBAL_ITEM_NAME(name) g_##name
+#define OPENSSL_CONST_ARRAY_SIZE(name) CONST_ARRAY_SIZE(libopeay, name)
+#else
+#define OPENSSL_GLOBAL_ARRAY_NAME(name) g_opera->libopeay_module.m_consts->m_cda_##name .m_array
+#define OPENSSL_GLOBAL_ITEM_NAME(name)  g_opera->libopeay_module.m_consts->m_cdi_##name .m_item
+#define OPENSSL_CONST_ARRAY_SIZE(name)  (g_opera->libopeay_module.m_consts->m_cda_##name .m_size)
+// Add namedefines above
+#endif // Complex globals
+
+#define OPENSSL_GLOBAL_NAME_it(name)		OPENSSL_GLOBAL_ITEM_NAME(name##_it) 
+#define OPENSSL_GLOBAL_NAME_item_tt(name)	OPENSSL_GLOBAL_ITEM_NAME(name##_item_tt)
+#define OPENSSL_GLOBAL_NAME_tt(name)		OPENSSL_GLOBAL_ITEM_NAME(name##_tt)
+#define OPENSSL_GLOBAL_NAME_ch_tt(name)		OPENSSL_GLOBAL_ARRAY_NAME(name##_ch_tt)
+#define OPENSSL_GLOBAL_NAME_seq_tt(name)	OPENSSL_GLOBAL_ARRAY_NAME(name##_seq_tt)
+#define OPENSSL_GLOBAL_NAME_adbtbl(name)	OPENSSL_GLOBAL_ARRAY_NAME(name##_adbtbl)
+#define OPENSSL_GLOBAL_NAME_adb(name)		OPENSSL_GLOBAL_ITEM_NAME(name##_adb)
+#define OPENSSL_GLOBAL_NAME_aux(name)		OPENSSL_GLOBAL_ITEM_NAME(name##_aux)
+
+#define OPENSSL_PREFIX_CONST_ARRAY(prefix, structname, name, modulename)	PREFIX_CONST_ARRAY(prefix, structname, name, modulename##_CONST)
+#define OPENSSL_CONST_ARRAY(prefix, structname, name, modulename)			CONST_ARRAY(prefix, structname, name, modulename##_CONST)
+#define OPENSSL_PREFIX_CONST_ITEM(prefix, structname, name, modulename)		PREFIX_CONST_ITEM(prefix, structname, name, modulename##_CONST)
+
+#endif /* MODULES_LIBOPEAY_ARRAYS_H */
diff -Naur openssl-1.0.0q.orig/libopeay_capabilities.h openssl-1.0.0q/libopeay_capabilities.h
--- openssl-1.0.0q.orig/libopeay_capabilities.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/libopeay_capabilities.h	2017-04-25 16:23:40.898798308 +0200
@@ -0,0 +1,16 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 1995-2008 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+**
+*/
+
+#ifndef LIBOPEAY_CAPABILITIES_H
+#define LIBOPEAY_CAPABILITIES_H
+
+// This module has the fixed intermediate certificate search
+#define LIBOPEAY_CAP_FIXED_INTERMEDIATE_SEARCH
+
+#endif /* LIBOPEAY_CAPABILITIES_H */
diff -Naur openssl-1.0.0q.orig/libopeay_constants.cpp openssl-1.0.0q/libopeay_constants.cpp
--- openssl-1.0.0q.orig/libopeay_constants.cpp	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/libopeay_constants.cpp	2017-04-25 16:23:40.898798308 +0200
@@ -0,0 +1,73 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 1995-2008 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+// Inside wrapper. No need for default include files
+
+#ifndef HAS_COMPLEX_GLOBALS
+
+#include "modules/libopeay/libopeay_arrays.h"
+
+void LibopeayModule::AddComplexConstGlobal(Libopeay_ConstBase *item)
+{
+	if(item)
+		item->Into(&global_const_list);
+}
+
+void LibopeayModule::InitGlobalsL()
+{
+	m_consts = new (ELeave) Libopeay_GlobalConst_Data;
+
+	if(global_const_list.Empty())
+		return; // If nothing to do, don't bother
+
+	// Alloc, if necessary
+	InitGlobalsPhaseL(1);
+	// Init members
+	InitGlobalsPhaseL(2);
+}
+
+void LibopeayModule::InitGlobalsPhaseL(int phase)
+{
+	Libopeay_ConstBase *item = (Libopeay_ConstBase *) global_const_list.First();
+
+	while(item)
+	{
+		item->InitL(phase);
+
+		item = (Libopeay_ConstBase *) item->Suc();
+	}
+}
+
+void LibopeayModule::DestroyGlobals()
+{
+	Libopeay_ConstBase *item = (Libopeay_ConstBase *) global_const_list.First();
+
+	while(item)
+	{
+		item->Destroy();
+
+		item = (Libopeay_ConstBase *) item->Suc();
+	}
+
+	delete m_consts;
+	m_consts = NULL;
+}
+
+LibopeayModule::Libopeay_ConstBase::Libopeay_ConstBase()
+{
+	g_opera->libopeay_module.AddComplexConstGlobal(this);
+}
+
+LibopeayModule::Libopeay_ConstBase::~Libopeay_ConstBase()
+{
+	if(InList())
+		Out();
+}
+
+
+#endif // HAS_COMPLEX_GLOBALS
diff -Naur openssl-1.0.0q.orig/libopeay_constants.h openssl-1.0.0q/libopeay_constants.h
--- openssl-1.0.0q.orig/libopeay_constants.h	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/libopeay_constants.h	2017-04-25 16:23:40.899798155 +0200
@@ -0,0 +1,361 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 1995-2008 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+#ifndef MODULES_LIBOPEAY_LIBOPEAY_CONSTANTS_H
+#define MODULES_LIBOPEAY_LIBOPEAY_CONSTANTS_H
+
+#if !defined HAS_COMPLEX_GLOBALS
+
+#ifdef OPENSSL_SYS_WIN32
+/* Under Win32 thes are defined in wincrypt.h */
+#undef PKCS7_ISSUER_AND_SERIAL
+#undef PKCS7_SIGNER_INFO
+#undef X509_NAME
+#undef X509_CERT_PAIR
+#undef OCSP_REQUEST
+#undef OCSP_RESPONSE
+#endif
+
+#include <openssl/cryptlib.h>
+#include <openssl/asn1t.h>
+#include <openssl/bn.h>
+#ifndef OPENSSL_NO_DH
+#include <openssl/dh.h>
+#endif
+#ifndef OPENSSL_NO_DSA
+#include <openssl/dsa.h>
+#endif
+#include <openssl/err.h>
+#include <openssl/evp.h>
+#include <openssl/rand.h>
+#ifndef OPENSSL_NO_RSA
+#include <openssl/rsa.h>
+#endif
+#include <openssl/x509v3.h>
+
+#include "modules/libopeay/crypto/asn1/asn1_locl.h"
+#include "modules/libopeay/crypto/evp/evp_locl.h"
+
+
+class Libopeay_GlobalConst_Data
+{
+public:
+	ASN1_ADB_SEQ_DECLARE(PKCS7);
+	ASN1_ADB_SEQ_DECLARE(POLICYQUALINFO);
+
+	ASN1_ADB_TEMPLATE_DECLARE(p7default);
+	ASN1_ADB_TEMPLATE_DECLARE(policydefault);
+
+	ASN1_CHOICE_cb_DECLARE(DIST_POINT_NAME);
+
+	ASN1_CHOICE_DECLARE(GENERAL_NAME);
+
+	ASN1_ITEM_TEMPLATE_DECLARE(ASN1_SEQUENCE_ANY);
+	ASN1_ITEM_TEMPLATE_DECLARE(ASN1_SET_ANY);
+	ASN1_ITEM_TEMPLATE_DECLARE(AUTHORITY_INFO_ACCESS);
+	ASN1_ITEM_TEMPLATE_DECLARE(CERTIFICATEPOLICIES);
+	ASN1_ITEM_TEMPLATE_DECLARE(CRL_DIST_POINTS);
+	ASN1_ITEM_TEMPLATE_DECLARE(GENERAL_NAMES);
+	ASN1_ITEM_TEMPLATE_DECLARE(EXTENDED_KEY_USAGE);
+	ASN1_ITEM_TEMPLATE_DECLARE(PKCS7_ATTR_SIGN);
+	ASN1_ITEM_TEMPLATE_DECLARE(POLICY_MAPPINGS);
+	ASN1_ITEM_TEMPLATE_DECLARE(X509_ALGORS);
+	ASN1_ITEM_TEMPLATE_DECLARE(X509_NAME_ENTRIES);
+	ASN1_ITEM_TEMPLATE_DECLARE(X509_NAME_INTERNAL);
+	ASN1_ITEM_TEMPLATE_DECLARE(X509_EXTENSIONS);
+
+#if defined(_SSL_USE_OPENSSL_) && !defined(_USE_SYSTEM_LIBCRYPTO_)
+	ASN1_SEQ_AUX_DECLARE(DHparams);
+#endif
+	ASN1_SEQ_AUX_DECLARE(PKCS7);
+	ASN1_SEQ_AUX_DECLARE(PKCS7_RECIP_INFO);
+	ASN1_SEQ_AUX_DECLARE(PKCS7_SIGNER_INFO);
+	ASN1_SEQ_AUX_DECLARE(RSAPrivateKey);
+	ASN1_SEQ_AUX_DECLARE(RSAPublicKey);
+	ASN1_SEQ_AUX_DECLARE(X509);
+	ASN1_SEQ_AUX_DECLARE(X509_CINF);
+	ASN1_SEQ_AUX_DECLARE(X509_PUBKEY);
+
+	ASN1_SEQUENCE_DECLARE(ACCESS_DESCRIPTION);
+	ASN1_SEQUENCE_DECLARE(AUTHORITY_KEYID);
+	ASN1_SEQUENCE_DECLARE(BASIC_CONSTRAINTS);
+	ASN1_SEQUENCE_DECLARE(DIST_POINT);
+	ASN1_SEQUENCE_DECLARE(EDIPARTYNAME);
+	ASN1_SEQUENCE_DECLARE(GENERAL_SUBTREE);
+	ASN1_SEQUENCE_DECLARE(ISSUING_DIST_POINT);
+	ASN1_SEQUENCE_DECLARE(NAME_CONSTRAINTS);
+	ASN1_SEQUENCE_DECLARE(NOTICEREF);
+	ASN1_SEQUENCE_DECLARE(OTHERNAME);
+#if defined(_SSL_USE_OPENSSL_) && !defined(_USE_SYSTEM_LIBCRYPTO_)
+	ASN1_SEQUENCE_DECLARE(PBE2PARAM);
+	ASN1_SEQUENCE_DECLARE(PBKDF2PARAM);
+#endif
+	ASN1_SEQUENCE_DECLARE(PKCS7_DIGEST);
+	ASN1_SEQUENCE_DECLARE(PKCS7_ENC_CONTENT);
+	ASN1_SEQUENCE_DECLARE(PKCS7_ENCRYPT);
+	ASN1_SEQUENCE_DECLARE(PKCS7_ENVELOPE);
+	ASN1_SEQUENCE_DECLARE(PKCS7_ISSUER_AND_SERIAL);
+	ASN1_SEQUENCE_DECLARE(PKCS7_SIGN_ENVELOPE);
+	ASN1_SEQUENCE_DECLARE(PKCS7_SIGNED);
+	ASN1_SEQUENCE_DECLARE(PKEY_USAGE_PERIOD);
+	ASN1_SEQUENCE_DECLARE(POLICY_CONSTRAINTS);
+	ASN1_SEQUENCE_DECLARE(POLICY_MAPPING);
+	ASN1_SEQUENCE_DECLARE(POLICYINFO);
+	ASN1_SEQUENCE_DECLARE(POLICYQUALINFO);
+	ASN1_SEQUENCE_DECLARE(PROXY_CERT_INFO_EXTENSION);
+	ASN1_SEQUENCE_DECLARE(PROXY_POLICY);
+	ASN1_SEQUENCE_DECLARE(SXNET);
+	ASN1_SEQUENCE_DECLARE(SXNETID);
+	ASN1_SEQUENCE_DECLARE(USERNOTICE) ;
+	ASN1_SEQUENCE_DECLARE(X509_ALGOR);
+	ASN1_SEQUENCE_DECLARE(X509_CERT_AUX);
+	ASN1_SEQUENCE_DECLARE(X509_EXTENSION);
+	ASN1_SEQUENCE_DECLARE(X509_NAME_ENTRY);
+	ASN1_SEQUENCE_DECLARE(X509_SIG);
+	ASN1_SEQUENCE_DECLARE(X509_VAL);
+
+	ASN1_TYPE_TEMPLATE_DECLARE(ASN1_ANY);
+	ASN1_TYPE_TEMPLATE_DECLARE(ASN1_BIT_STRING);
+	ASN1_TYPE_TEMPLATE_DECLARE(ASN1_BOOLEAN);
+	//ASN1_TYPE_TEMPLATE_DECLARE(ASN1_BMPSTRING);
+	ASN1_TYPE_TEMPLATE_DECLARE(ASN1_ENUMERATED);
+	ASN1_TYPE_TEMPLATE_DECLARE(ASN1_FBOOLEAN);
+	//ASN1_TYPE_TEMPLATE_DECLARE(ASN1_GENERALSTRING);
+	ASN1_TYPE_TEMPLATE_DECLARE(ASN1_GENERALIZEDTIME);
+	ASN1_TYPE_TEMPLATE_DECLARE(ASN1_IA5STRING);
+	ASN1_TYPE_TEMPLATE_DECLARE(ASN1_INTEGER);
+	ASN1_TYPE_TEMPLATE_DECLARE(ASN1_NULL);
+	ASN1_TYPE_TEMPLATE_DECLARE(ASN1_OBJECT);
+	ASN1_TYPE_TEMPLATE_DECLARE(ASN1_OCTET_STRING);
+	ASN1_TYPE_TEMPLATE_DECLARE(ASN1_OCTET_STRING_NDEF);
+	ASN1_TYPE_TEMPLATE_DECLARE(ASN1_PRINTABLE);
+	//ASN1_TYPE_TEMPLATE_DECLARE(ASN1_PRINTABLESTRING);
+	ASN1_TYPE_TEMPLATE_DECLARE(ASN1_SEQUENCE);
+	ASN1_TYPE_TEMPLATE_DECLARE(ASN1_T61STRING);
+	ASN1_TYPE_TEMPLATE_DECLARE(ASN1_TIME);
+	ASN1_TYPE_TEMPLATE_DECLARE(ASN1_UTF8STRING);
+	ASN1_TYPE_TEMPLATE_DECLARE(BIGNUM);
+	ASN1_TYPE_TEMPLATE_DECLARE(CBIGNUM);
+	ASN1_TYPE_TEMPLATE_DECLARE(DIRECTORYSTRING);
+	ASN1_TYPE_TEMPLATE_DECLARE(DISPLAYTEXT);
+	ASN1_TYPE_TEMPLATE_DECLARE(LONG);
+	ASN1_TYPE_TEMPLATE_DECLARE(X509_NAME);
+	ASN1_TYPE_TEMPLATE_DECLARE(ZLONG);
+
+#ifndef OPENSSL_NO_DSA
+	ASN1_SEQ_AUX_DECLARE(DSA_SIG);
+	ASN1_SEQ_AUX_DECLARE(DSAPrivateKey);
+	ASN1_SEQ_AUX_DECLARE(DSAparams);
+	ASN1_SEQUENCE_DECLARE(dsa_pub_internal);
+	ASN1_CHOICE_cb_DECLARE(DSAPublicKey);
+	DECLARE_EVP_MD_ITEM(dss1_md);
+	DECLARE_MODULE_CONST_ITEM(DSA_METHOD, openssl_dsa_meth);
+#endif
+
+#ifndef OPENSSL_NO_OCSP
+	ASN1_SEQUENCE_DECLARE(OCSP_SIGNATURE);
+	ASN1_SEQUENCE_DECLARE(OCSP_CERTID);
+	ASN1_SEQUENCE_DECLARE(OCSP_ONEREQ);
+	ASN1_SEQUENCE_DECLARE(OCSP_REQINFO);
+	ASN1_SEQUENCE_DECLARE(OCSP_REQUEST);
+	ASN1_SEQUENCE_DECLARE(OCSP_RESPBYTES);
+	ASN1_SEQUENCE_DECLARE(OCSP_RESPONSE);
+	ASN1_CHOICE_DECLARE(OCSP_RESPID);
+	ASN1_SEQUENCE_DECLARE(OCSP_REVOKEDINFO);
+	ASN1_CHOICE_DECLARE(OCSP_CERTSTATUS);
+	ASN1_SEQUENCE_DECLARE(OCSP_SINGLERESP);
+	ASN1_SEQUENCE_DECLARE(OCSP_RESPDATA);
+	ASN1_SEQUENCE_DECLARE(OCSP_BASICRESP);
+	ASN1_SEQUENCE_DECLARE(OCSP_CRLID);
+	ASN1_SEQUENCE_DECLARE(OCSP_SERVICELOC);
+#endif
+
+#ifdef LIBOPEAY_PKCS12_SUPPORT
+	ASN1_SEQUENCE_DECLARE(PKCS12);
+	ASN1_SEQUENCE_DECLARE(PKCS12_MAC_DATA);
+	ASN1_ADB_TEMPLATE_DECLARE(bag_default);
+	ASN1_ADB_SEQ_DECLARE(PKCS12_BAGS);
+	ASN1_SEQUENCE_DECLARE(PKCS12_BAGS);
+	ASN1_ADB_TEMPLATE_DECLARE(safebag_default);
+	ASN1_ADB_SEQ_DECLARE(PKCS12_SAFEBAG);
+	ASN1_SEQUENCE_DECLARE(PKCS12_SAFEBAG);
+	ASN1_ITEM_TEMPLATE_DECLARE(PKCS12_SAFEBAGS);
+	ASN1_ITEM_TEMPLATE_DECLARE(PKCS12_AUTHSAFES);
+	ASN1_SEQUENCE_DECLARE(PBEPARAM);
+#endif
+
+#ifdef LIBOPEAY_ASYNCHRONOUS_KEYGENERATION
+	ASN1_SEQ_AUX_DECLARE(X509_REQ_INFO);
+	ASN1_SEQUENCE_DECLARE(NETSCAPE_SPKAC);
+	ASN1_SEQ_AUX_DECLARE(X509_REQ);
+	ASN1_SEQUENCE_DECLARE(NETSCAPE_SPKI);
+#endif
+
+#if defined LIBOPEAY_PKCS12_SUPPORT || defined LIBOPEAY_ASYNCHRONOUS_KEYGENERATION || defined USE_OPENSSL_CERTIFICATE_VERIFICATION
+	ASN1_SEQ_AUX_DECLARE(PKCS8_PRIV_KEY_INFO);
+#endif
+
+#if defined _SSL_USE_OPENSSL_ || defined USE_OPENSSL_CERTIFICATE_VERIFICATION
+	ASN1_SEQUENCE_DECLARE(X509_REVOKED);
+	ASN1_SEQ_AUX_DECLARE(X509_CRL);
+	ASN1_SEQ_AUX_DECLARE(X509_CRL_INFO);
+#if defined(_SSL_USE_OPENSSL_) && !defined(_USE_SYSTEM_LIBCRYPTO_)
+	ASN1_SEQ_AUX_DECLARE(NETSCAPE_CERT_SEQUENCE);
+#endif
+#endif // _SSL_USE_OPENSSL_ || USE_OPENSSL_CERTIFICATE_VERIFICATION
+
+#if defined _SSL_USE_OPENSSL_ || defined USE_OPENSSL_CERTIFICATE_VERIFICATION
+	ASN1_CHOICE_DECLARE(X509_ATTRIBUTE_SET);
+	ASN1_SEQUENCE_DECLARE(X509_ATTRIBUTE);
+#endif // _SSL_USE_OPENSSL_ || USE_OPENSSL_CERTIFICATE_VERIFICATION
+
+	DECLARE_X509V3_EXT_METHOD(v3_akey_id);
+	DECLARE_X509V3_EXT_METHOD(v3_bcons);
+	DECLARE_X509V3_EXT_METHOD(v3_cpols);
+	DECLARE_X509V3_EXT_METHOD(v3_crl_invdate);
+	DECLARE_X509V3_EXT_METHOD(v3_crl_hold);
+	DECLARE_X509V3_EXT_METHOD(v3_crl_num);
+	DECLARE_X509V3_EXT_METHOD(v3_crl_reason);
+	DECLARE_X509V3_EXT_METHOD(v3_crld);
+	DECLARE_X509V3_EXT_METHOD(v3_delta_crl);
+	DECLARE_X509V3_EXT_METHOD(v3_ext_ku);
+	DECLARE_X509V3_EXT_METHOD(v3_freshest_crl);
+	DECLARE_X509V3_EXT_METHOD(v3_idp);
+	DECLARE_X509V3_EXT_METHOD(v3_info);
+	DECLARE_X509V3_EXT_METHOD(v3_inhibit_anyp);
+	DECLARE_X509V3_EXT_METHOD(v3_key_usage);
+	DECLARE_X509V3_EXT_METHOD(v3_name_constraints);
+	DECLARE_X509V3_EXT_METHOD(v3_nscert);
+	DECLARE_X509V3_EXT_METHOD(v3_ocsp_accresp);
+	DECLARE_X509V3_EXT_METHOD(v3_ocsp_acutoff);
+	DECLARE_X509V3_EXT_METHOD(v3_ocsp_crlid);
+	DECLARE_X509V3_EXT_METHOD(v3_ocsp_nocheck);
+	DECLARE_X509V3_EXT_METHOD(v3_ocsp_nonce);
+	DECLARE_X509V3_EXT_METHOD(v3_ocsp_serviceloc);
+	DECLARE_X509V3_EXT_METHOD(v3_pci);
+	DECLARE_X509V3_EXT_METHOD(v3_pkey_usage_period);
+	DECLARE_X509V3_EXT_METHOD(v3_policy_constraints);
+	DECLARE_X509V3_EXT_METHOD(v3_policy_mappings);
+	DECLARE_X509V3_EXT_METHOD(v3_sinfo);
+	DECLARE_X509V3_EXT_METHOD(v3_skey_id);
+	DECLARE_X509V3_EXT_METHOD(v3_sxnet);
+
+#ifndef OPENSSL_NO_RFC3779
+	DECLARE_X509V3_EXT_METHOD(v3_addr);
+	DECLARE_X509V3_EXT_METHOD(v3_asid);
+#endif
+
+	DECLARE_BIO_METHOD_ITEM(bio_enc__methods_enc);
+	DECLARE_BIO_METHOD_ITEM(bio_md__methods_md);
+	DECLARE_BIO_METHOD_ITEM(bss_mem__mem_method);
+	DECLARE_BIO_METHOD_ITEM(bss_null__null_method);
+
+#ifdef _SSL_USE_OPENSSL_
+	DECLARE_BLOCK_CIPHER(aes_128);
+	DECLARE_BLOCK_CIPHER(aes_256);
+	DECLARE_BLOCK_CIPHER(des_ede3);
+	DECLARE_EVP_CIPHER_ITEM(r4_cipher);
+#endif // _SSL_USE_OPENSSL_
+#ifdef LIBOPEAY_USE_RC4_256
+	DECLARE_EVP_CIPHER_ITEM(r4_256_cipher);
+#endif
+#if defined SSL_USE_WEAK_CIPHERS
+	DECLARE_BLOCK_CIPHER(des_ede);
+	DECLARE_EVP_CIPHER_ITEM(r4_40_cipher);
+#endif
+#if defined LIBOPEAY_PKCS12_SUPPORT || defined SSL_USE_WEAK_CIPHERS
+	DECLARE_EVP_CIPHER_ITEM(rc2_cbc);
+	DECLARE_EVP_CIPHER_ITEM(r2_40_cbc_cipher);
+#endif
+
+#ifndef OPENSSL_NO_MD2
+	DECLARE_EVP_MD_ITEM(md2_md);
+#endif
+	DECLARE_EVP_MD_ITEM(md5_md);
+	DECLARE_EVP_MD_ITEM(sha1_md);
+	DECLARE_EVP_MD_ITEM(sha224_md);
+	DECLARE_EVP_MD_ITEM(sha256_md);
+	DECLARE_EVP_MD_ITEM(sha384_md);
+	DECLARE_EVP_MD_ITEM(sha512_md);
+#ifndef OPENSSL_NO_RIPEMD
+	DECLARE_EVP_MD_ITEM(ripemd160_md);
+#endif
+
+	// Const items. Sorted alphabetically by name.
+	DECLARE_MODULE_CONST_ITEM(ASN1_PRIMITIVE_FUNCS,         bignum_pf);
+	DECLARE_MODULE_CONST_ITEM(BIGNUM,                       const_one);
+#ifndef OPENSSL_NO_DH
+	DECLARE_MODULE_CONST_ITEM(DH_METHOD,                    dh_ossl);
+#endif
+#if (defined(_SSL_USE_OPENSSL_) || defined(USE_OPENSSL_CERTIFICATE_VERIFICATION)) && !defined(_USE_SYSTEM_LIBCRYPTO_) && !defined(OPENSSL_NO_DH)
+	DECLARE_MODULE_CONST_ITEM(EVP_PKEY_ASN1_METHOD,         dh_ameth__dh_asn1_meth);
+	DECLARE_MODULE_CONST_ITEM(EVP_PKEY_METHOD,              dh_pmeth__dh_pkey_meth);
+#endif
+#if (defined(_SSL_USE_OPENSSL_) || defined(USE_OPENSSL_CERTIFICATE_VERIFICATION)) && !defined(_USE_SYSTEM_LIBCRYPTO_) && !defined(OPENSSL_NO_DSA)
+	DECLARE_MODULE_CONST_ITEM(EVP_PKEY_ASN1_METHOD,         dsa_ameth__dsa_asn1_meth0);
+	DECLARE_MODULE_CONST_ITEM(EVP_PKEY_ASN1_METHOD,         dsa_ameth__dsa_asn1_meth1);
+	DECLARE_MODULE_CONST_ITEM(EVP_PKEY_ASN1_METHOD,         dsa_ameth__dsa_asn1_meth2);
+	DECLARE_MODULE_CONST_ITEM(EVP_PKEY_ASN1_METHOD,         dsa_ameth__dsa_asn1_meth3);
+	DECLARE_MODULE_CONST_ITEM(EVP_PKEY_ASN1_METHOD,         dsa_ameth__dsa_asn1_meth4);
+	DECLARE_MODULE_CONST_ITEM(EVP_PKEY_METHOD,              dsa_pmeth__dsa_pkey_meth);
+#endif
+
+	DECLARE_MODULE_CONST_ITEM(ERR_FNS,                      err__err_defaults);
+	DECLARE_MODULE_CONST_ITEM(EVP_PKEY_ASN1_METHOD,         hm_ameth__hmac_asn1_meth);
+	DECLARE_MODULE_CONST_ITEM(EVP_PKEY_METHOD,              hm_pmeth__hmac_pkey_meth);
+	DECLARE_MODULE_CONST_ITEM(ASN1_PRIMITIVE_FUNCS,         long_pf);
+#if (defined(_SSL_USE_OPENSSL_) || defined(USE_OPENSSL_CERTIFICATE_VERIFICATION) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)) && !defined(_USE_SYSTEM_LIBCRYPTO_)
+	DECLARE_MODULE_CONST_ITEM(RAND_METHOD,                  rand_ssleay_meth);
+#endif
+	DECLARE_MODULE_CONST_ITEM(EVP_PKEY_ASN1_METHOD,         rsa_ameth__rsa_asn1_meth0);
+	DECLARE_MODULE_CONST_ITEM(EVP_PKEY_ASN1_METHOD,         rsa_ameth__rsa_asn1_meth1);
+	DECLARE_MODULE_CONST_ITEM(RSA_METHOD,                   rsa_pkcs1_eay_meth);
+	DECLARE_MODULE_CONST_ITEM(EVP_PKEY_METHOD,              rsa_pmeth__rsa_pkey_meth);
+	DECLARE_MODULE_CONST_ITEM(X509_CRL_METHOD,              x_crl__int_crl_meth);
+	DECLARE_MODULE_CONST_ITEM(ASN1_EXTERN_FUNCS,            x509_name_ff);
+
+	// Const arrays. Sorted alphabetically by name.
+	DECLARE_MODULE_CONST_ARRAY(const EVP_PKEY_ASN1_METHOD*, ameth_lib__standard_methods);
+	DECLARE_MODULE_CONST_ARRAY(struct tag_name_st,          asn1_gen__tnst);
+	DECLARE_MODULE_CONST_ARRAY(const char*,                 asn1_mon);
+	DECLARE_MODULE_CONST_ARRAY(ENUMERATED_NAMES,            crl_reasons);
+	DECLARE_MODULE_CONST_ARRAY(X509_VERIFY_PARAM,           default_table);
+#if defined(_SSL_USE_OPENSSL_) && !defined(_USE_SYSTEM_LIBCRYPTO_) && defined(LIBOPEAY_PKCS12_SUPPORT)
+	DECLARE_MODULE_CONST_ARRAY(struct evp_pbe_ctl_st,       evp_pbe__builtin_pbe);
+#endif
+	DECLARE_MODULE_CONST_ARRAY(const X509V3_EXT_METHOD*,    ext_dat__standard_exts);
+	DECLARE_MODULE_CONST_ARRAY(BIT_STRING_BITNAME,          key_usage_type_table);
+#ifndef OPERA_SMALL_VERSION
+	DECLARE_MODULE_CONST_ARRAY(unsigned int,                ln_objs);
+#endif
+#ifdef ADS12
+	DECLARE_MODULE_CONST_ARRAY(unsigned char,               lvalues);
+#endif
+	DECLARE_MODULE_CONST_ARRAY(ASN1_OBJECT,                 nid_objs);
+	DECLARE_MODULE_CONST_ARRAY(BIT_STRING_BITNAME,          ns_cert_type_table);
+	DECLARE_MODULE_CONST_ARRAY(unsigned int,                obj_objs);
+	DECLARE_MODULE_CONST_ARRAY(struct nid_triple_st,        obj_xref__sigoid_srt);
+	// It's important that obj_xref__sigoid_srt_xref is initialized
+	// after obj_xref__sigoid_srt.
+	DECLARE_MODULE_CONST_ARRAY(const struct nid_triple_st*, obj_xref__sigoid_srt_xref);
+	DECLARE_MODULE_CONST_ARRAY(const EVP_PKEY_METHOD*,      pmeth_lib__standard_methods);
+	DECLARE_MODULE_CONST_ARRAY(BIT_STRING_BITNAME,          v3_crld__reason_flags);
+#ifndef OPERA_SMALL_VERSION
+	DECLARE_MODULE_CONST_ARRAY(unsigned int,                sn_objs);
+#endif
+	DECLARE_MODULE_CONST_ARRAY(X509_TRUST,                  trstandard);
+	DECLARE_MODULE_CONST_ARRAY(X509V3_EXT_METHOD,           v3_ns_ia5_list);
+	DECLARE_MODULE_CONST_ARRAY(X509V3_EXT_METHOD,           v3_alt);
+	DECLARE_MODULE_CONST_ARRAY(X509_PURPOSE,                xstandard);
+};
+
+#define libopeay_CONST_MODULE_CLASS_NAME Libopeay_GlobalConst_Data
+
+#endif /* HAS_COMPLEX_GLOBALS */
+
+#endif /* MODULES_LIBOPEAY_LIBOPEAY_CONSTANTS_H*/
